/* MacBinary t@C̓ǉ    */
/*  Copyright(c)2001 by T.Toda */
#include <stdio.h>

#ifdef	MSDOS
#define	OPENMODE	"rb"
#else
#define	OPENMODE	"r"
#endif

static	void	puthex(unsigned long, int);
static	unsigned long	makelong(unsigned char *);
static	unsigned short	makeshort(unsigned char *);

int	main(int argc, char **argv, char **envp)
{
	FILE	*fp;
	struct{
		unsigned char	oldversion;
		unsigned char	fnamelen;
		char	filename[63];
		char	filetype[4];
		char	creator[4];
		unsigned char	finderflag1;
		unsigned char	zerofill1;
		unsigned char	vertical[2];
		unsigned char	horizontal[2];
		unsigned char	folderid[2];
		unsigned char	protected;
		unsigned char	zerofill2;
		unsigned char	datafolk[4];
		unsigned char	resourcefolk[4];
		unsigned char	created[4];
		unsigned char	modified[4];
		unsigned char	infocomment[2];	/* for MacBinary II */
		unsigned char	finderflag2;	/* for MacBinary II */
		unsigned char	signature[4];	/* for MacBinary III */
		unsigned char	fnamescript;	/* for MacBinary III */
		unsigned char	extendedflag;	/* for MacBinary III */
		unsigned char	reserved[8];
		unsigned char	unpackedsize[4];	/* for MacBinary II */
		unsigned char	secondheader[2];	/* for MacBinary II */
		unsigned char	version;	/* for MacBinary II */
		unsigned char	minversion;	/* for MacBinary II */
		unsigned char	crc[2];	/* for MacBinary II */
		unsigned char	osid[2];	/* for MacBinary I */
	}	header;
	int	i;

	if( argc > 2 ){
		fputs("Usage : ", stderr);
		fputs(argv[0], stderr);
		fputs(" [infile]]\n", stderr);
		return	4;
	}
	if( argc < 2 ){
		fp = stdin;
	}
	else if(( fp = fopen(argv[1],OPENMODE)) == NULL ){
		fputs("Can't Open '", stderr);
		fputs(argv[1], stderr);
		fputs("'.\n", stderr);
		return	8;
	}
	fread(&header, sizeof(header), 1, fp);
	fputs("Binary Version: Old Style = ",stdout);
	puthex(header.oldversion, 2);
	fputs("H    New Style = ",stdout);
	puthex(header.version, 2);
	fputs("H    Required = ",stdout);
	puthex(header.minversion, 2);	
	fputs("H\nFileName: '", stdout);
	for( i=0 ; i < (unsigned) header.fnamelen ; i++ ){
		putchar(header.filename[i]);
	}
	fputs("'\nFileType: '", stdout);
	for( i=0 ; i < 4 ; i++ ){
		putchar(header.filetype[i]);
	}
	fputs("'  Creator: '", stdout);
	for( i=0 ; i < 4 ; i++ ){
		putchar(header.creator[i]);
	}
	fputs("'    CRC: ",stdout);
	puthex(makeshort(header.crc), 4);
	fputs("H    OSID: ",stdout);
	puthex(makeshort(header.osid), 4);
	fputs("H\nData Folk: ", stdout);
	puthex(makelong(header.datafolk), 8);
	fputs("H bytes    Resource Folk: ", stdout);
	puthex(makelong(header.resourcefolk), 8);
	fputs("H bytes\nGetInfo Comment: ", stdout);
	puthex(makeshort(header.infocomment), 4);
	fputs("H bytes    Secondary Header: ", stdout);
	puthex(makeshort(header.secondheader), 4);
	fputs("H bytes\nUnpacked Size: ", stdout);
	puthex(makelong(header.unpackedsize), 8);
	fputs("H bytes    Protected Flag: ", stdout);
	puthex(header.protected, 2);
	fputs("H    \nPosition: (", stdout);
	puthex(makeshort(header.horizontal), 4);
	fputs("H,", stdout);
	puthex(makeshort(header.vertical), 4);
	fputs("H)    Finder Flag: ", stdout);
	puthex(header.finderflag1, 2);
	puthex(header.finderflag2, 2);
	fputs("H    Folder ID: ", stdout);
	puthex(makeshort(header.folderid), 4);
	fputs("H\nCreated Date Data: ", stdout);
	puthex(makelong(header.created), 8);
	fputs("H    Modified Date Data: ", stdout);
	puthex(makelong(header.modified), 8);
	fputs("H\n", stdout);
	return	0;
}

static void	puthex(unsigned long c, int l)
{
	static	char	const	hexnum[] = "0123456789ABCDEF";
	char	result[9];

	if(l > 8)l = 8;
	if(l < 1)l = 1;
	result[l] = 0;
	result[--l] = hexnum[c % 0x10];
	while( l-- )
		result[l] = hexnum[(c >>= 4) % 0x10];
	fputs(result, stdout);
}

static	unsigned long	makelong(unsigned char *buffer)
{
	return	( ((long)buffer[0] << 24 ) | 
	      	  ((long)buffer[1] << 16 ) | 
	      	  ((long)buffer[2] <<  8 ) | 
	      	  ((long)buffer[3] ) );
}

static	unsigned short	makeshort(unsigned char *buffer)
{
	return	( ((short)buffer[0] <<  8 ) | 
	      	  ((short)buffer[1] ) );
}
